"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CycleAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class CycleAsyncIterable {
    constructor(xs) {
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return cycleAsync(this.xs);
    }
}
exports.CycleAsyncIterable = CycleAsyncIterable;
function cycleAsync(xs) {
    return tslib_1.__asyncGenerator(this, arguments, function* cycleAsync_1() {
        var e_1, _a;
        while (true) {
            try {
                for (var xs_1 = (e_1 = void 0, tslib_1.__asyncValues(xs)), xs_1_1; xs_1_1 = yield tslib_1.__await(xs_1.next()), !xs_1_1.done;) {
                    const x = xs_1_1.value;
                    // tslint:disable-next-line
                    yield yield tslib_1.__await(x);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (xs_1_1 && !xs_1_1.done && (_a = xs_1.return)) yield tslib_1.__await(_a.call(xs_1));
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    });
}
