"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JoinAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class JoinAsyncIterable {
    constructor(xss) {
        this.xss = xss;
    }
    [Symbol.asyncIterator]() {
        return joinAsync(this.xss);
    }
}
exports.JoinAsyncIterable = JoinAsyncIterable;
function joinAsync(xss) {
    return tslib_1.__asyncGenerator(this, arguments, function* joinAsync_1() {
        var e_1, _a, e_2, _b;
        try {
            for (var xss_1 = tslib_1.__asyncValues(xss), xss_1_1; xss_1_1 = yield tslib_1.__await(xss_1.next()), !xss_1_1.done;) {
                const xs = xss_1_1.value;
                try {
                    for (var xs_1 = (e_2 = void 0, tslib_1.__asyncValues(xs)), xs_1_1; xs_1_1 = yield tslib_1.__await(xs_1.next()), !xs_1_1.done;) {
                        const x = xs_1_1.value;
                        yield yield tslib_1.__await(x);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (xs_1_1 && !xs_1_1.done && (_b = xs_1.return)) yield tslib_1.__await(_b.call(xs_1));
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (xss_1_1 && !xss_1_1.done && (_a = xss_1.return)) yield tslib_1.__await(_a.call(xss_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
