"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CycleIterable = void 0;
/* @internal */
class CycleIterable {
    constructor(xs) {
        this.xs = xs;
    }
    [Symbol.iterator]() {
        return cycle(this.xs);
    }
}
exports.CycleIterable = CycleIterable;
function* cycle(xs) {
    while (true) {
        for (const x of xs) {
            yield x;
        }
    }
}
