"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JoinIterable = void 0;
/* @internal */
class JoinIterable {
    constructor(xss) {
        this.xss = xss;
    }
    [Symbol.iterator]() {
        return join(this.xss);
    }
}
exports.JoinIterable = JoinIterable;
function* join(xss) {
    for (const xs of xss) {
        for (const x of xs) {
            yield x;
        }
    }
}
