"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConsAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class ConsAsyncIterable {
    constructor(x, xs) {
        this.x = x;
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return consAsync(this.x, this.xs);
    }
}
exports.ConsAsyncIterable = ConsAsyncIterable;
function consAsync(x, xs) {
    return tslib_1.__asyncGenerator(this, arguments, function* consAsync_1() {
        var e_1, _a;
        yield yield tslib_1.__await(yield tslib_1.__await(x));
        try {
            for (var xs_1 = tslib_1.__asyncValues(xs), xs_1_1; xs_1_1 = yield tslib_1.__await(xs_1.next()), !xs_1_1.done;) {
                const y = xs_1_1.value;
                yield yield tslib_1.__await(y);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (xs_1_1 && !xs_1_1.done && (_a = xs_1.return)) yield tslib_1.__await(_a.call(xs_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
