"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class FilterAsyncIterable {
    constructor(p, xs) {
        this.p = p;
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return filterAsync(this.p, this.xs);
    }
}
exports.FilterAsyncIterable = FilterAsyncIterable;
function filterAsync(p, xs) {
    return tslib_1.__asyncGenerator(this, arguments, function* filterAsync_1() {
        var e_1, _a;
        try {
            for (var xs_1 = tslib_1.__asyncValues(xs), xs_1_1; xs_1_1 = yield tslib_1.__await(xs_1.next()), !xs_1_1.done;) {
                const x = xs_1_1.value;
                if (p(x)) {
                    yield yield tslib_1.__await(x);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (xs_1_1 && !xs_1_1.done && (_a = xs_1.return)) yield tslib_1.__await(_a.call(xs_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
